# Changelog

## [v4.0.17](https://github.com/testfx/testfx/tree/v4.0.17) (2023-08-17)

[Full Changelog](https://github.com/testfx/testfx/compare/v4.0.16-alpha...v4.0.17)

**Merged pull requests:**

- Update release script [\#784](https://github.com/TestFX/TestFX/pull/784) ([mvsoder](https://github.com/mvsoder))
- Improve exception message when missing libgtk-3-0 [\#782](https://github.com/TestFX/TestFX/pull/782) ([mvsoder](https://github.com/mvsoder))
- Improve stability of ShortcutKeyTest a bit more [\#781](https://github.com/TestFX/TestFX/pull/781) ([mvsoder](https://github.com/mvsoder))
- Add ubuntu-22.04 to build runners [\#780](https://github.com/TestFX/TestFX/pull/780) ([mvsoder](https://github.com/mvsoder))
- Center test stages on the screen [\#779](https://github.com/TestFX/TestFX/pull/779) ([mvsoder](https://github.com/mvsoder))
- Use a common pattern for cleaning up after a test [\#778](https://github.com/TestFX/TestFX/pull/778) ([mvsoder](https://github.com/mvsoder))
- Gradle cleanup [\#777](https://github.com/TestFX/TestFX/pull/777) ([mvsoder](https://github.com/mvsoder))
- Fix for intermittent test failure [\#776](https://github.com/TestFX/TestFX/pull/776) ([mvsoder](https://github.com/mvsoder))
- Fix memory leak due to ParametersImpl [\#774](https://github.com/TestFX/TestFX/pull/774) ([mvsoder](https://github.com/mvsoder))
- README update name, badges and requirements [\#772](https://github.com/TestFX/TestFX/pull/772) ([mvsoder](https://github.com/mvsoder))
- Fix CI workflow name to be more descriptive [\#771](https://github.com/TestFX/TestFX/pull/771) ([mvsoder](https://github.com/mvsoder))
- \(fix for TestFX 4 JDK 8 support\) Fix cannot find symbol Platform.requestNextPulse\(\). [\#770](https://github.com/TestFX/TestFX/pull/770) ([mvsoder](https://github.com/mvsoder))
- \(fix\) Improve BoundsQueryUtilsTest to take screen boundary into account. [\#769](https://github.com/TestFX/TestFX/pull/769) ([mvsoder](https://github.com/mvsoder))
- \(fix for TestFX 4 JDK 8 support\) Remove module-info.java files. [\#767](https://github.com/TestFX/TestFX/pull/767) ([mvsoder](https://github.com/mvsoder))
- \(fix for TestFX 4 JDK 8 support\) Fix JavaDoc invalid flag html5. [\#765](https://github.com/TestFX/TestFX/pull/765) ([mvsoder](https://github.com/mvsoder))
- \(chore\) Enable GitHub Actions with JDK 8 [\#761](https://github.com/TestFX/TestFX/pull/761) ([mvsoder](https://github.com/mvsoder))
- \(fix\) Remove the compile-time dependency on ParametersImpl. [\#757](https://github.com/TestFX/TestFX/pull/757) ([mvsoder](https://github.com/mvsoder))
- Update license header year to 2023 [\#752](https://github.com/TestFX/TestFX/pull/752) ([mvsoder](https://github.com/mvsoder))
- Old year in license header cause problem [\#729](https://github.com/TestFX/TestFX/pull/729) ([AndFr](https://github.com/AndFr))
- \(feature\) Add the option to export an image to different filetype than png. [\#726](https://github.com/TestFX/TestFX/pull/726) ([AndFr](https://github.com/AndFr))
- Fix list indentation in README [\#708](https://github.com/TestFX/TestFX/pull/708) ([Marcono1234](https://github.com/Marcono1234))
- Use HTTPS for links and update them in README [\#707](https://github.com/TestFX/TestFX/pull/707) ([Marcono1234](https://github.com/Marcono1234))
- Fix header level of Gradle and Maven subsections in README [\#706](https://github.com/TestFX/TestFX/pull/706) ([Marcono1234](https://github.com/Marcono1234))
- \[checkstyle\] Try and fix cannot initialize root module error. [\#705](https://github.com/TestFX/TestFX/pull/705) ([brcolow](https://github.com/brcolow))
- JUnit5 TestFX extension to execute @Test within JavaFX UI thread [\#702](https://github.com/TestFX/TestFX/pull/702) ([RalphSteinhagen](https://github.com/RalphSteinhagen))
- \[jpms\] Change some module scopes. [\#686](https://github.com/TestFX/TestFX/pull/686) ([brcolow](https://github.com/brcolow))
- \[gradle\] Remove bnd plugin to fix uber JAR. [\#685](https://github.com/TestFX/TestFX/pull/685) ([brcolow](https://github.com/brcolow))
- \[build\] Try removing dependencies from JAR. [\#684](https://github.com/TestFX/TestFX/pull/684) ([brcolow](https://github.com/brcolow))
- \[deps\] Change assertj-core dependency from api to implementation. [\#683](https://github.com/TestFX/TestFX/pull/683) ([brcolow](https://github.com/brcolow))
- \[deps\] Make hamcrest-core testImplementation for testfx-core. [\#681](https://github.com/TestFX/TestFX/pull/681) ([brcolow](https://github.com/brcolow))
- \[deps\] Remove hamcrest-junit dependency from testfx-junit. [\#680](https://github.com/TestFX/TestFX/pull/680) ([brcolow](https://github.com/brcolow))
- \[deps\] Remove classifier from published POM \(for openjfx\). [\#679](https://github.com/TestFX/TestFX/pull/679) ([brcolow](https://github.com/brcolow))
- \[docs\] Get Javadoc working on Jigsaw again. [\#676](https://github.com/TestFX/TestFX/pull/676) ([brcolow](https://github.com/brcolow))
- \[chore\] Add fake bnd version for jitpack. [\#672](https://github.com/TestFX/TestFX/pull/672) ([brcolow](https://github.com/brcolow))
- \[chore\] Explicitly set the 'Bundle-Version' for bnd/osgi. [\#671](https://github.com/TestFX/TestFX/pull/671) ([brcolow](https://github.com/brcolow))
- \[enhancement\] Including module-info.java in the JAR artifacts. [\#669](https://github.com/TestFX/TestFX/pull/669) ([brcolow](https://github.com/brcolow))
- \[ci\] Use OpenJDK 8 when in deploy script. [\#668](https://github.com/TestFX/TestFX/pull/668) ([brcolow](https://github.com/brcolow))

## [v4.0.16-alpha](https://github.com/testfx/testfx/tree/v4.0.16-alpha) (2019-08-06)

[Full Changelog](https://github.com/testfx/testfx/compare/v4.0.15-alpha...v4.0.16-alpha)

**Merged pull requests:**

- \[chore\] Fix Bintray badge on README. [\#666](https://github.com/TestFX/TestFX/pull/666) ([brcolow](https://github.com/brcolow))
- \[chore\] Upgrade Gradle to 5.5.1, update dependencies. [\#665](https://github.com/TestFX/TestFX/pull/665) ([brcolow](https://github.com/brcolow))
- documentation fixes [\#664](https://github.com/TestFX/TestFX/pull/664) ([frenchy64](https://github.com/frenchy64))
- Make junit5 dependency compileOnly. [\#663](https://github.com/TestFX/TestFX/pull/663) ([brcolow](https://github.com/brcolow))
- Add docs to TableView\(Matchers/Assert\) about viewport. [\#657](https://github.com/TestFX/TestFX/pull/657) ([brcolow](https://github.com/brcolow))
- \(chore\) Update license header copyright to 2019. [\#646](https://github.com/TestFX/TestFX/pull/646) ([brcolow](https://github.com/brcolow))
- \(ci\) Remove Java 8 from Travis macOS matrix.  [\#644](https://github.com/TestFX/TestFX/pull/644) ([brcolow](https://github.com/brcolow))
- Matcher for matching ListViews with given value in their selection. [\#642](https://github.com/TestFX/TestFX/pull/642) ([htmoia](https://github.com/htmoia))
- \[chore\] Bump checkstyle from 8.9 to 8.14. [\#637](https://github.com/TestFX/TestFX/pull/637) ([brcolow](https://github.com/brcolow))
- \[ci\] Oracle JDK 10 is deprecated, switch to OpenJDK 10. [\#636](https://github.com/TestFX/TestFX/pull/636) ([brcolow](https://github.com/brcolow))
- \(fix\) ApplicationExtension must free UI events after each test \#632 [\#633](https://github.com/TestFX/TestFX/pull/633) ([arnobl](https://github.com/arnobl))
- \(enhancement\) Support matcher/assertion on Styleables. [\#631](https://github.com/TestFX/TestFX/pull/631) ([brcolow](https://github.com/brcolow))
- \(chore\) Add output when deploy syncs to Maven Central. [\#630](https://github.com/TestFX/TestFX/pull/630) ([brcolow](https://github.com/brcolow))
- \(fix\) Public glass robot API no longer has destroy method. [\#627](https://github.com/TestFX/TestFX/pull/627) ([brcolow](https://github.com/brcolow))
- \(chore\) Explicitly set testfx.robot for CI builds. [\#626](https://github.com/TestFX/TestFX/pull/626) ([brcolow](https://github.com/brcolow))
- Make glass robot default on all platforms. [\#625](https://github.com/TestFX/TestFX/pull/625) ([brcolow](https://github.com/brcolow))
- \(fix\) Auto-deploy via Travis - bintray fix. [\#621](https://github.com/TestFX/TestFX/pull/621) ([brcolow](https://github.com/brcolow))
- \(fix\) Remove call to limit\(-1\) in MoveRobotImpl.moveMouseStepwiseBetween [\#620](https://github.com/TestFX/TestFX/pull/620) ([Clashsoft](https://github.com/Clashsoft))
- \(fix\) KeyCombination on Mac with Java10 and AwtRobotAdapter [\#613](https://github.com/TestFX/TestFX/pull/613) ([Ortner](https://github.com/Ortner))
- \(test\) Fix Locale in text matchers [\#611](https://github.com/TestFX/TestFX/pull/611) ([Ortner](https://github.com/Ortner))
- \(fix\) Refactor/cleanup of HiDPI handling code. [\#609](https://github.com/TestFX/TestFX/pull/609) ([brcolow](https://github.com/brcolow))
- \[enhancement\] Support Java\(FX\) 11. [\#606](https://github.com/TestFX/TestFX/pull/606) ([brcolow](https://github.com/brcolow))
- \(fix\) Make sure AWT and Glass robots work in HiDPI and normal DPI. [\#602](https://github.com/TestFX/TestFX/pull/602) ([brcolow](https://github.com/brcolow))
- \(fix\) Add Text class case to NodeQueryUtils.hasNodeText\(..\). [\#600](https://github.com/TestFX/TestFX/pull/600) ([brcolow](https://github.com/brcolow))
- \(fix\) typing of characters in the background [\#598](https://github.com/TestFX/TestFX/pull/598) ([brcolow](https://github.com/brcolow))
- \(chore\) Bump Appveyor Java 10 version. [\#595](https://github.com/TestFX/TestFX/pull/595) ([brcolow](https://github.com/brcolow))
- 589 shortcut [\#591](https://github.com/TestFX/TestFX/pull/591) ([Ortner](https://github.com/Ortner))
- Fix misclosed string messing up syntax highlight on README.md [\#588](https://github.com/TestFX/TestFX/pull/588) ([oowekyala](https://github.com/oowekyala))
- Spelling correction [\#585](https://github.com/TestFX/TestFX/pull/585) ([david-arteaga](https://github.com/david-arteaga))
- Add new matcher for MenuItem elements with tests [\#584](https://github.com/TestFX/TestFX/pull/584) ([Alexilmarranen](https://github.com/Alexilmarranen))
- Try and fix hiDPI for multi-monitor. [\#580](https://github.com/TestFX/TestFX/pull/580) ([brcolow](https://github.com/brcolow))
- \(fix\) Add imports to test classes in README. [\#579](https://github.com/TestFX/TestFX/pull/579) ([brcolow](https://github.com/brcolow))
- \(fix\) Refactor queryAsX methods to be defaults. [\#578](https://github.com/TestFX/TestFX/pull/578) ([brcolow](https://github.com/brcolow))
- \(doc\) Reword doc to match behaviour. [\#576](https://github.com/TestFX/TestFX/pull/576) ([scolej](https://github.com/scolej))
- Made cursor interpolation calculation variable settable using system params [\#575](https://github.com/TestFX/TestFX/pull/575) ([adamlb94](https://github.com/adamlb94))
- \(fix\) Use Long.getLong, Integer.getInteger, and Boolean.getBoolean fo… [\#572](https://github.com/TestFX/TestFX/pull/572) ([brcolow](https://github.com/brcolow))
- \(fix\) Remove @Unstable and @Stable annotations. [\#569](https://github.com/TestFX/TestFX/pull/569) ([brcolow](https://github.com/brcolow))
- \(chore\) Fix some code style issues. [\#567](https://github.com/TestFX/TestFX/pull/567) ([brcolow](https://github.com/brcolow))
- \(fix\) Get Java 10 working on CI. [\#560](https://github.com/TestFX/TestFX/pull/560) ([brcolow](https://github.com/brcolow))
- \(chore\) Add Java 10 builds to Appveyor and Travis CI. [\#558](https://github.com/TestFX/TestFX/pull/558) ([brcolow](https://github.com/brcolow))
- \(chore\) Cleanup Spotbugs gradle log summary. [\#557](https://github.com/TestFX/TestFX/pull/557) ([brcolow](https://github.com/brcolow))
- \(fix\) Try and double the timeout for WaitForAsyncUtilsTest. [\#555](https://github.com/TestFX/TestFX/pull/555) ([brcolow](https://github.com/brcolow))
- \(fix\) Remove usage of 'javafx.macosx.embedded' property. [\#554](https://github.com/TestFX/TestFX/pull/554) ([brcolow](https://github.com/brcolow))
- \(chore\) Remove jdepend from build.gradle, bump gradle plugins. [\#552](https://github.com/TestFX/TestFX/pull/552) ([brcolow](https://github.com/brcolow))
- \(chore\) Add Javadocs to testfx-junit subproject. [\#551](https://github.com/TestFX/TestFX/pull/551) ([brcolow](https://github.com/brcolow))
- \(fix\) Operate on getWindows, without any wrapping. [\#550](https://github.com/TestFX/TestFX/pull/550) ([brcolow](https://github.com/brcolow))
- \(fix\) Explicitly install Java 9 on travis macOS. [\#547](https://github.com/TestFX/TestFX/pull/547) ([brcolow](https://github.com/brcolow))
- \(fix\) Publish the Bintray artifacts on deploy. [\#545](https://github.com/TestFX/TestFX/pull/545) ([brcolow](https://github.com/brcolow))

## [v4.0.15-alpha](https://github.com/testfx/testfx/tree/v4.0.15-alpha) (2018-10-08)

[Full Changelog](https://github.com/testfx/testfx/compare/v4.0.14-alpha...v4.0.15-alpha)

## [v4.0.14-alpha](https://github.com/testfx/testfx/tree/v4.0.14-alpha) (2018-08-29)

[Full Changelog](https://github.com/testfx/testfx/compare/v4.0.13-alpha...v4.0.14-alpha)

## [v4.0.13-alpha](https://github.com/testfx/testfx/tree/v4.0.13-alpha) (2018-03-23)

[Full Changelog](https://github.com/testfx/testfx/compare/v4.0.12-alpha...v4.0.13-alpha)

**Merged pull requests:**

- Support different UI scales \(hidpi\) [\#544](https://github.com/TestFX/TestFX/pull/544) ([brcolow](https://github.com/brcolow))
- \(fix\) Maintain order of nodes as returned by Node.lookupAll\(..\). [\#542](https://github.com/TestFX/TestFX/pull/542) ([brcolow](https://github.com/brcolow))
- \(fix\) Skip before\_install, script, and after\_success when deploying. [\#539](https://github.com/TestFX/TestFX/pull/539) ([brcolow](https://github.com/brcolow))

## [v4.0.12-alpha](https://github.com/testfx/testfx/tree/v4.0.12-alpha) (2018-02-22)

[Full Changelog](https://github.com/testfx/testfx/compare/v4.0.11-alpha...v4.0.12-alpha)

**Merged pull requests:**

- \(chore\) Add a check for github\_changelog\_generator gem. [\#537](https://github.com/TestFX/TestFX/pull/537) ([brcolow](https://github.com/brcolow))
- \(chore\) Bump AssertJ 3.8.0 -\> 3.9.1. [\#536](https://github.com/TestFX/TestFX/pull/536) ([brcolow](https://github.com/brcolow))
- \(enhancement\) Add more matchers/assertions for Text instances. [\#535](https://github.com/TestFX/TestFX/pull/535) ([brcolow](https://github.com/brcolow))
- \(chore\) Add assertThat tests to junit subprojects. [\#534](https://github.com/TestFX/TestFX/pull/534) ([brcolow](https://github.com/brcolow))
- \(enhancement\) Add support for AssertJ assertions. [\#532](https://github.com/TestFX/TestFX/pull/532) ([brcolow](https://github.com/brcolow))
- \(fix\) Fix the region that is used to capture Bounds. [\#530](https://github.com/TestFX/TestFX/pull/530) ([psaikkonen](https://github.com/psaikkonen))
- \(chore\) Document Java 8 minimum requirement. [\#529](https://github.com/TestFX/TestFX/pull/529) ([brcolow](https://github.com/brcolow))
- \(enhancement\) Allow FxRobot.write\(..\) sleep time to be configured. [\#528](https://github.com/TestFX/TestFX/pull/528) ([brcolow](https://github.com/brcolow))
- \(chore\) Bump gradle 4.4.1 =\> 4.5.1 [\#526](https://github.com/TestFX/TestFX/pull/526) ([brcolow](https://github.com/brcolow))
- \(chore\) Bump checkstyle from 8.5 to 8.8. [\#525](https://github.com/TestFX/TestFX/pull/525) ([brcolow](https://github.com/brcolow))
- \[WIP\] Color matchers, refactor ColorUtils. [\#524](https://github.com/TestFX/TestFX/pull/524) ([brcolow](https://github.com/brcolow))
- \(enhancement\) Add some more offset convenience methods. [\#523](https://github.com/TestFX/TestFX/pull/523) ([brcolow](https://github.com/brcolow))
- \(enhancement\) Add isFocused/isNotFocused to NodeMatchers. [\#522](https://github.com/TestFX/TestFX/pull/522) ([brcolow](https://github.com/brcolow))
- \(chore\) Add test for write\(..\). [\#521](https://github.com/TestFX/TestFX/pull/521) ([brcolow](https://github.com/brcolow))
- \(chore\) Fix JUnit 5 README example visibility modifiers. [\#520](https://github.com/TestFX/TestFX/pull/520) ([brcolow](https://github.com/brcolow))
- \(chore\) Add note about testfx-legacy deprecation to README. [\#517](https://github.com/TestFX/TestFX/pull/517) ([brcolow](https://github.com/brcolow))
- \(chore\) Add a cleanup handler to release script. [\#514](https://github.com/TestFX/TestFX/pull/514) ([brcolow](https://github.com/brcolow))

## [v4.0.11-alpha](https://github.com/testfx/testfx/tree/v4.0.11-alpha) (2018-01-23)

[Full Changelog](https://github.com/testfx/testfx/compare/v4.0.10-alpha...v4.0.11-alpha)

**Merged pull requests:**

- \(chore\) Bump appveyor Java 9 version. [\#512](https://github.com/TestFX/TestFX/pull/512) ([brcolow](https://github.com/brcolow))
- MoveRobotImpl slowness fix [\#511](https://github.com/TestFX/TestFX/pull/511) ([seggcsont](https://github.com/seggcsont))
- \(chore\) Add GitHub issue template. [\#509](https://github.com/TestFX/TestFX/pull/509) ([brcolow](https://github.com/brcolow))
- \(chore\) Bump gradle 4.4 =\> 4.4.1 [\#504](https://github.com/TestFX/TestFX/pull/504) ([brcolow](https://github.com/brcolow))
- \(chore\) Cleanup FxToolkit by inlining some methods. [\#503](https://github.com/TestFX/TestFX/pull/503) ([brcolow](https://github.com/brcolow))
- \(chore\) Add Gradle/Maven Java 9 usage info to README. [\#502](https://github.com/TestFX/TestFX/pull/502) ([brcolow](https://github.com/brcolow))
- \(enhancement\) Improve TableViewMatchers containsRow javadocs. [\#501](https://github.com/TestFX/TestFX/pull/501) ([brcolow](https://github.com/brcolow))
- \(chore\) Update license header year. [\#500](https://github.com/TestFX/TestFX/pull/500) ([brcolow](https://github.com/brcolow))
- \(chore\) Cleanup comment section headers in junit subprojects. [\#496](https://github.com/TestFX/TestFX/pull/496) ([brcolow](https://github.com/brcolow))
- \(chore\) Cleanup the README. [\#495](https://github.com/TestFX/TestFX/pull/495) ([brcolow](https://github.com/brcolow))
- \(chore\) Remove ext.isJava9 in favor of native Gradle methods. [\#493](https://github.com/TestFX/TestFX/pull/493) ([brcolow](https://github.com/brcolow))
- \(fix\) Fix some bash strict mode errors in release.sh. [\#491](https://github.com/TestFX/TestFX/pull/491) ([brcolow](https://github.com/brcolow))
- \(fix\) Fix use of positional parameter in release.sh. [\#490](https://github.com/TestFX/TestFX/pull/490) ([brcolow](https://github.com/brcolow))
- \(enhancement\) Automatically sync to Maven Central when auto-deploying. [\#489](https://github.com/TestFX/TestFX/pull/489) ([brcolow](https://github.com/brcolow))
- \(enhancement\) Begin to automate the release process. [\#488](https://github.com/TestFX/TestFX/pull/488) ([brcolow](https://github.com/brcolow))
- \(chore\) Bump checkstyle 8.4 =\> 8.5, improve docs redundancy. [\#487](https://github.com/TestFX/TestFX/pull/487) ([brcolow](https://github.com/brcolow))
- \(chore\) Fully test ScrollRobotImpl. [\#486](https://github.com/TestFX/TestFX/pull/486) ([brcolow](https://github.com/brcolow))
- \(chore\) Try JaCoCo snapshot, cleanup BoundsQueryUtils. [\#485](https://github.com/TestFX/TestFX/pull/485) ([brcolow](https://github.com/brcolow))
- \(chore\) Remove or fix some ignored tests. [\#484](https://github.com/TestFX/TestFX/pull/484) ([brcolow](https://github.com/brcolow))
- \(chore\) Cleanup testfx-core tests. [\#483](https://github.com/TestFX/TestFX/pull/483) ([brcolow](https://github.com/brcolow))
- \(chore\) Cleanup code \(remove section comments, inline methods\). [\#482](https://github.com/TestFX/TestFX/pull/482) ([brcolow](https://github.com/brcolow))
- \(chore\) Cleanup testfx.robot\(.impl\). [\#480](https://github.com/TestFX/TestFX/pull/480) ([brcolow](https://github.com/brcolow))
- Add notice for Junit5 users in readme [\#478](https://github.com/TestFX/TestFX/pull/478) ([jcornaz](https://github.com/jcornaz))
- Cleanup RobotAdapters. [\#477](https://github.com/TestFX/TestFX/pull/477) ([brcolow](https://github.com/brcolow))
- \(chore\) Add test failure summary. [\#474](https://github.com/TestFX/TestFX/pull/474) ([brcolow](https://github.com/brcolow))
- \(chore\) Fix build.gradle line length. [\#473](https://github.com/TestFX/TestFX/pull/473) ([brcolow](https://github.com/brcolow))
- \(fix\) Add gdb apt package to each Travis matrix build. [\#472](https://github.com/TestFX/TestFX/pull/472) ([brcolow](https://github.com/brcolow))
- \(enhancement\) Simplify converting from Glass colors. [\#471](https://github.com/TestFX/TestFX/pull/471) ([brcolow](https://github.com/brcolow))
- \(enhancement\) Continue modularization [\#470](https://github.com/TestFX/TestFX/pull/470) ([brcolow](https://github.com/brcolow))
- Fixed Gitter link [\#469](https://github.com/TestFX/TestFX/pull/469) ([AdamCarroll](https://github.com/AdamCarroll))

## [v4.0.10-alpha](https://github.com/testfx/testfx/tree/v4.0.10-alpha) (2017-11-28)

[Full Changelog](https://github.com/testfx/testfx/compare/v4.0.9-alpha...v4.0.10-alpha)

**Merged pull requests:**

- \(release\) TestFX 4.0.10-alpha [\#468](https://github.com/TestFX/TestFX/pull/468) ([brcolow](https://github.com/brcolow))
- \(chore\) Update junit5 to 5.1.0-M1 [\#467](https://github.com/TestFX/TestFX/pull/467) ([brcolow](https://github.com/brcolow))
- \(chore\) Fix coveralls badge URL. [\#465](https://github.com/TestFX/TestFX/pull/465) ([brcolow](https://github.com/brcolow))
- \(chore\) Switch from findbugs to spotbugs. [\#463](https://github.com/TestFX/TestFX/pull/463) ([brcolow](https://github.com/brcolow))
- \(enhancement\) Produce better descriptions of actual if mismatch. [\#461](https://github.com/TestFX/TestFX/pull/461) ([brcolow](https://github.com/brcolow))
- \(enhancement\) Add module-info.java to testfx-core. [\#460](https://github.com/TestFX/TestFX/pull/460) ([brcolow](https://github.com/brcolow))
- \(chore\) Try to fix codecov a different way. [\#459](https://github.com/TestFX/TestFX/pull/459) ([brcolow](https://github.com/brcolow))
- \(chore\) Fix codecov paths for core project. [\#458](https://github.com/TestFX/TestFX/pull/458) ([brcolow](https://github.com/brcolow))
- \(chore\) Utilize Travis CI log folding. [\#457](https://github.com/TestFX/TestFX/pull/457) ([brcolow](https://github.com/brcolow))
- \(chore\) Update README. [\#456](https://github.com/TestFX/TestFX/pull/456) ([brcolow](https://github.com/brcolow))
- \(chore\) Bump gradle 4.2.1 -\> 4.3.1. [\#454](https://github.com/TestFX/TestFX/pull/454) ([brcolow](https://github.com/brcolow))
- \(chore\) Remove dependency on Guava. [\#453](https://github.com/TestFX/TestFX/pull/453) ([brcolow](https://github.com/brcolow))
- \(fix\) Remove Findbugs annotations. [\#450](https://github.com/TestFX/TestFX/pull/450) ([brcolow](https://github.com/brcolow))
- \(enhancement\) Issue \#441 - OSGi Headers in Manifest [\#446](https://github.com/TestFX/TestFX/pull/446) ([jtkb](https://github.com/jtkb))
- \(chore\) Add Java 9 builds to Appveyor. [\#445](https://github.com/TestFX/TestFX/pull/445) ([brcolow](https://github.com/brcolow))
- \(chore\) Bump gradle 4.1 =\> 4.2.1 [\#444](https://github.com/TestFX/TestFX/pull/444) ([brcolow](https://github.com/brcolow))
- \(chore\) Add Java 9 build for macOS to Travis. [\#439](https://github.com/TestFX/TestFX/pull/439) ([brcolow](https://github.com/brcolow))
- Flaky test: org.testfx.cases.acceptance.FxAssertBasicTest \> button\_has\_label  [\#438](https://github.com/TestFX/TestFX/pull/438) ([Oliver-Loeffler](https://github.com/Oliver-Loeffler))

## [v4.0.9-alpha](https://github.com/testfx/testfx/tree/v4.0.9-alpha) (2017-11-25)

[Full Changelog](https://github.com/testfx/testfx/compare/v4.0.8-alpha...v4.0.9-alpha)

## [v4.0.8-alpha](https://github.com/testfx/testfx/tree/v4.0.8-alpha) (2017-10-04)

[Full Changelog](https://github.com/testfx/testfx/compare/v4.0.7-alpha...v4.0.8-alpha)

**Merged pull requests:**

- \(release\) TestFX 4.0.8-alpha [\#434](https://github.com/TestFX/TestFX/pull/434) ([brcolow](https://github.com/brcolow))
- \[WIP\] \(refactor\) Use Java-version-independent adapter for internal API [\#429](https://github.com/TestFX/TestFX/pull/429) ([JordanMartinez](https://github.com/JordanMartinez))
- \(chore\) Use template in gradle-license-plugin. [\#428](https://github.com/TestFX/TestFX/pull/428) ([brcolow](https://github.com/brcolow))
- \(chore\) Remove Travis macOS "partial headless" build. [\#426](https://github.com/TestFX/TestFX/pull/426) ([brcolow](https://github.com/brcolow))
- \(chore\) Bump Travis macOS Xcode 8.2 =\> 9. [\#424](https://github.com/TestFX/TestFX/pull/424) ([brcolow](https://github.com/brcolow))
- \(chore\) Bump gradle 3.5 =\> 4.1 [\#423](https://github.com/TestFX/TestFX/pull/423) ([brcolow](https://github.com/brcolow))
- \[RFC\] \(feature\) Re-add capture support by moving it to DebugUtils [\#422](https://github.com/TestFX/TestFX/pull/422) ([JordanMartinez](https://github.com/JordanMartinez))
- \[RFC\] Extract failed test debugger code into its own utiltiy class [\#421](https://github.com/TestFX/TestFX/pull/421) ([JordanMartinez](https://github.com/JordanMartinez))
- \[RFC\] Increase debugability [\#418](https://github.com/TestFX/TestFX/pull/418) ([JordanMartinez](https://github.com/JordanMartinez))
- \(refactor\) Better failure message for ShortcutKeyTest [\#353](https://github.com/TestFX/TestFX/pull/353) ([brcolow](https://github.com/brcolow))

## [v4.0.7-alpha](https://github.com/testfx/testfx/tree/v4.0.7-alpha) (2017-08-21)

[Full Changelog](https://github.com/testfx/testfx/compare/v4.0.6-alpha...v4.0.7-alpha)

**Merged pull requests:**

- \(release\) TestFX 4.0.7-alpha [\#416](https://github.com/TestFX/TestFX/pull/416) ([brcolow](https://github.com/brcolow))
- Refactor spock [\#414](https://github.com/TestFX/TestFX/pull/414) ([JordanMartinez](https://github.com/JordanMartinez))
- \[chore\] Split Travis apt packages for \*nix by JDK. [\#413](https://github.com/TestFX/TestFX/pull/413) ([brcolow](https://github.com/brcolow))
- \(refactor\) Make ApplicationTest\#start\(\) not abstract [\#412](https://github.com/TestFX/TestFX/pull/412) ([AustinShalit](https://github.com/AustinShalit))
- Fix incompatibility with Junit5 RC2 [\#409](https://github.com/TestFX/TestFX/pull/409) ([JLLeitschuh](https://github.com/JLLeitschuh))
- \(feature\) Add Spock variant of TestFX [\#404](https://github.com/TestFX/TestFX/pull/404) ([JordanMartinez](https://github.com/JordanMartinez))
- \(chore\) Bump gradle version 3.5-rc3 -\> 3.5. [\#394](https://github.com/TestFX/TestFX/pull/394) ([brcolow](https://github.com/brcolow))
- \(chore\) Fix license URL and update copyright dates. [\#393](https://github.com/TestFX/TestFX/pull/393) ([brcolow](https://github.com/brcolow))
- Prevent blocking JVM shutdown by using daemon threads [\#390](https://github.com/TestFX/TestFX/pull/390) ([raniejade](https://github.com/raniejade))
- \(chore\) Bump mockito and monocle versions. [\#388](https://github.com/TestFX/TestFX/pull/388) ([brcolow](https://github.com/brcolow))
- \(chore\) Bump gradle version 3.5-rc2 -\> 3.5-rc3. [\#387](https://github.com/TestFX/TestFX/pull/387) ([brcolow](https://github.com/brcolow))
- \(fix\) Fix drag and drop test flakiness. [\#383](https://github.com/TestFX/TestFX/pull/383) ([brcolow](https://github.com/brcolow))
- \[WIP\] \(refactor\) Fix many IntelliJ inspection issues. [\#382](https://github.com/TestFX/TestFX/pull/382) ([brcolow](https://github.com/brcolow))
- \(fix\) Pass along application parameters. [\#381](https://github.com/TestFX/TestFX/pull/381) ([brcolow](https://github.com/brcolow))
- \(fix\) Make TableViewMatchers work with cell factories. [\#379](https://github.com/TestFX/TestFX/pull/379) ([brcolow](https://github.com/brcolow))

## [v4.0.6-alpha](https://github.com/testfx/testfx/tree/v4.0.6-alpha) (2017-03-22)

[Full Changelog](https://github.com/testfx/testfx/compare/v4.0.5-alpha...v4.0.6-alpha)

**Merged pull requests:**

- \(release\) TestFX 4.0.6-alpha [\#376](https://github.com/TestFX/TestFX/pull/376) ([brcolow](https://github.com/brcolow))
- \(chore\) Bump gradle wrapper version. [\#373](https://github.com/TestFX/TestFX/pull/373) ([brcolow](https://github.com/brcolow))
- \(cleanup\) Cleanup utility classes. [\#371](https://github.com/TestFX/TestFX/pull/371) ([brcolow](https://github.com/brcolow))
- \(refactor\) Use better data structure for exception stack. [\#370](https://github.com/TestFX/TestFX/pull/370) ([brcolow](https://github.com/brcolow))
- \(feature\) Adds button matchers for default and cancel buttons. [\#368](https://github.com/TestFX/TestFX/pull/368) ([cguckes](https://github.com/cguckes))
- \(fix\) Make HeadlessPlatform constructor accessible. [\#365](https://github.com/TestFX/TestFX/pull/365) ([brcolow](https://github.com/brcolow))
- \(feature\) Introduce the concept of motion. [\#363](https://github.com/TestFX/TestFX/pull/363) ([brcolow](https://github.com/brcolow))
- \(refactor\) Replace Guava newX\(\) calls with regular constructors. [\#362](https://github.com/TestFX/TestFX/pull/362) ([brcolow](https://github.com/brcolow))
- \(chore\) Gradle: Upgrade from 3.2.1 to 3.3. [\#361](https://github.com/TestFX/TestFX/pull/361) ([brcolow](https://github.com/brcolow))
- \(chore\) Bump Checkstyle from 7.3 -\> 7.4. [\#360](https://github.com/TestFX/TestFX/pull/360) ([brcolow](https://github.com/brcolow))
- \(cleanup\) Don't ignore whitespace around enhanced for-loop. [\#358](https://github.com/TestFX/TestFX/pull/358) ([brcolow](https://github.com/brcolow))
- \(refactor\) Replace calls to FXRobot with Event.fireEvent. [\#355](https://github.com/TestFX/TestFX/pull/355) ([brcolow](https://github.com/brcolow))
- \(chore\) Bump Google Guava version from 20.0 -\> 21.0. [\#352](https://github.com/TestFX/TestFX/pull/352) ([brcolow](https://github.com/brcolow))
- 281: Vulnerability in WaitForAsyncUtils [\#351](https://github.com/TestFX/TestFX/pull/351) ([brcolow](https://github.com/brcolow))
- \(chore\) Opt-in to the travis trusty beta. [\#350](https://github.com/TestFX/TestFX/pull/350) ([brcolow](https://github.com/brcolow))
- Fix tests of jUnit5 adapter [\#347](https://github.com/TestFX/TestFX/pull/347) ([SimY4](https://github.com/SimY4))
- Bump the macOS travis image version. [\#345](https://github.com/TestFX/TestFX/pull/345) ([brcolow](https://github.com/brcolow))
- \(doc\) Add documentation to `matcher` package. [\#344](https://github.com/TestFX/TestFX/pull/344) ([JordanMartinez](https://github.com/JordanMartinez))
- \(release\) TestFX 4.0.5-alpha [\#343](https://github.com/TestFX/TestFX/pull/343) ([brcolow](https://github.com/brcolow))
- \(refactor\) Moved `ShortcutKeyTest` to core package. [\#342](https://github.com/TestFX/TestFX/pull/342) ([JordanMartinez](https://github.com/JordanMartinez))
- Doc api package [\#341](https://github.com/TestFX/TestFX/pull/341) ([JordanMartinez](https://github.com/JordanMartinez))
- Doc toolkit interfaces [\#340](https://github.com/TestFX/TestFX/pull/340) ([JordanMartinez](https://github.com/JordanMartinez))
- Doc toolkit package [\#339](https://github.com/TestFX/TestFX/pull/339) ([JordanMartinez](https://github.com/JordanMartinez))
- Replace all uber jar deps [\#338](https://github.com/TestFX/TestFX/pull/338) ([SimY4](https://github.com/SimY4))
- Junit5 adapter [\#337](https://github.com/TestFX/TestFX/pull/337) ([SimY4](https://github.com/SimY4))
- \(doc\) Add documentation to TextInputControls [\#335](https://github.com/TestFX/TestFX/pull/335) ([JordanMartinez](https://github.com/JordanMartinez))
- Document support package [\#334](https://github.com/TestFX/TestFX/pull/334) ([JordanMartinez](https://github.com/JordanMartinez))
- \(fix\) Use os-independent SHORTCUT, not CONTROL keycode [\#333](https://github.com/TestFX/TestFX/pull/333) ([JordanMartinez](https://github.com/JordanMartinez))
- Document finder package [\#332](https://github.com/TestFX/TestFX/pull/332) ([JordanMartinez](https://github.com/JordanMartinez))
- Document FxRobotInterface [\#331](https://github.com/TestFX/TestFX/pull/331) ([JordanMartinez](https://github.com/JordanMartinez))
- \(refactor\) Use Java 8 Streams, not Guava [\#330](https://github.com/TestFX/TestFX/pull/330) ([JordanMartinez](https://github.com/JordanMartinez))
- \(cleanup\) Use `getWidth()` and `getHeight()` rather than calculate it [\#329](https://github.com/TestFX/TestFX/pull/329) ([JordanMartinez](https://github.com/JordanMartinez))
- Add javadoc to util package [\#328](https://github.com/TestFX/TestFX/pull/328) ([JordanMartinez](https://github.com/JordanMartinez))
- Add documenttion to Locator interfaces [\#327](https://github.com/TestFX/TestFX/pull/327) ([JordanMartinez](https://github.com/JordanMartinez))
- Document query-related interfaces [\#326](https://github.com/TestFX/TestFX/pull/326) ([JordanMartinez](https://github.com/JordanMartinez))
- Add basic documentation to Robot classes [\#325](https://github.com/TestFX/TestFX/pull/325) ([JordanMartinez](https://github.com/JordanMartinez))
- Re-enable Findbugs linting. [\#324](https://github.com/TestFX/TestFX/pull/324) ([brcolow](https://github.com/brcolow))
- Update gradle wrapper version to 3.2.1 \(latest\). [\#322](https://github.com/TestFX/TestFX/pull/322) ([brcolow](https://github.com/brcolow))
- Add more Checkstyle rules, cleanup accordingly. [\#321](https://github.com/TestFX/TestFX/pull/321) ([brcolow](https://github.com/brcolow))
- Convert Shortcut to os-specific shortcut key [\#320](https://github.com/TestFX/TestFX/pull/320) ([JordanMartinez](https://github.com/JordanMartinez))
- Release all pressed keys after test finishes to prevent hanging [\#319](https://github.com/TestFX/TestFX/pull/319) ([JordanMartinez](https://github.com/JordanMartinez))
- Use Java8's Optional/Predicate/Function instead of Guava's [\#318](https://github.com/TestFX/TestFX/pull/318) ([aalmiray](https://github.com/aalmiray))
- Add gitter badge, fix maven central typo. [\#316](https://github.com/TestFX/TestFX/pull/316) ([brcolow](https://github.com/brcolow))
- Update dependencies. [\#315](https://github.com/TestFX/TestFX/pull/315) ([brcolow](https://github.com/brcolow))
- Re-enable Checkstyle, removing exisiting violations. [\#314](https://github.com/TestFX/TestFX/pull/314) ([brcolow](https://github.com/brcolow))
- Add Appveyor CI build script. [\#313](https://github.com/TestFX/TestFX/pull/313) ([brcolow](https://github.com/brcolow))
- Add building on macOS to travis. [\#312](https://github.com/TestFX/TestFX/pull/312) ([brcolow](https://github.com/brcolow))
- \(docs\) fix pom formatting [\#308](https://github.com/TestFX/TestFX/pull/308) ([feldoh](https://github.com/feldoh))
- Allow for matching a table row without specifying index. [\#303](https://github.com/TestFX/TestFX/pull/303) ([brcolow](https://github.com/brcolow))
- \(fix\) Close resources with try-resource in CaptureSupport. [\#298](https://github.com/TestFX/TestFX/pull/298) ([hastebrot](https://github.com/hastebrot))
- \(fix\) Add check to cleanup for active FX Application Thread. [\#288](https://github.com/TestFX/TestFX/pull/288) ([Ortner](https://github.com/Ortner))
- Add scroll left/right to ScrollRobot [\#285](https://github.com/TestFX/TestFX/pull/285) ([aalmiray](https://github.com/aalmiray))
- Add WindowMatchers class [\#284](https://github.com/TestFX/TestFX/pull/284) ([aalmiray](https://github.com/aalmiray))
- Fixes for suggestions by @hastebrot for ComboBoxMatchers [\#270](https://github.com/TestFX/TestFX/pull/270) ([brcolow](https://github.com/brcolow))
- \(feat\) Add `ComboBoxMatchers` functionality and tests. [\#269](https://github.com/TestFX/TestFX/pull/269) ([brcolow](https://github.com/brcolow))
- Added interactFast\(...\) Method to FxRobot\(Interface\) [\#268](https://github.com/TestFX/TestFX/pull/268) ([Ortner](https://github.com/Ortner))
- \(fix\) Java 8u40: Monocle `HeadlessPlatform` class not found. [\#265](https://github.com/TestFX/TestFX/pull/265) ([brcolow](https://github.com/brcolow))
- \(refactor\) Wrap Image into functional interface. [\#263](https://github.com/TestFX/TestFX/pull/263) ([hastebrot](https://github.com/hastebrot))

## [v4.0.5-alpha](https://github.com/testfx/testfx/tree/v4.0.5-alpha) (2016-12-20)

[Full Changelog](https://github.com/testfx/testfx/compare/v4.0.4-alpha...v4.0.5-alpha)

## [v4.0.4-alpha](https://github.com/testfx/testfx/tree/v4.0.4-alpha) (2016-03-29)

[Full Changelog](https://github.com/testfx/testfx/compare/v4.0.3-alpha...v4.0.4-alpha)

**Merged pull requests:**

- \(feat\) Introduce `FxRobot::bounds()` and `BoundsQuery`. [\#258](https://github.com/TestFX/TestFX/pull/258) ([hastebrot](https://github.com/hastebrot))
- \(refactor\) ApplicationService: Use Application instead of ApplicationFixture. [\#257](https://github.com/TestFX/TestFX/pull/257) ([hastebrot](https://github.com/hastebrot))

## [v4.0.3-alpha](https://github.com/testfx/testfx/tree/v4.0.3-alpha) (2016-03-25)

[Full Changelog](https://github.com/testfx/testfx/compare/v4.0.2-alpha...v4.0.3-alpha)

**Merged pull requests:**

- \(feat\) TextFlowMatchers: Add matchers for the text of a TextFlow. [\#259](https://github.com/TestFX/TestFX/pull/259) ([brcolow](https://github.com/brcolow))
- \(feat\) TableViewMatchers: Add containsRow\(\). [\#255](https://github.com/TestFX/TestFX/pull/255) ([brcolow](https://github.com/brcolow))
- \(feat\) ListViewMatchers: Add hasPlaceholder\(Node placeholder\). [\#252](https://github.com/TestFX/TestFX/pull/252) ([brcolow](https://github.com/brcolow))
- \(feat\) ListViewMatchers: Add isEmpty\(\). [\#251](https://github.com/TestFX/TestFX/pull/251) ([brcolow](https://github.com/brcolow))
- \(refactor\) `NodeQuery`: Rename methods to `match()`, `nth()` and `query()`. [\#250](https://github.com/TestFX/TestFX/pull/250) ([hastebrot](https://github.com/hastebrot))
- \(feat\) Add PixelMatcher to CaptureSupport. [\#248](https://github.com/TestFX/TestFX/pull/248) ([hastebrot](https://github.com/hastebrot))

## [v4.0.2-alpha](https://github.com/testfx/testfx/tree/v4.0.2-alpha) (2016-02-22)

[Full Changelog](https://github.com/testfx/testfx/compare/v4.0.1-alpha...v4.0.2-alpha)

**Merged pull requests:**

- \(feat\) Add `FxRobot::interrupt()` method to wait for the JavaFX thread. [\#240](https://github.com/TestFX/TestFX/pull/240) ([hastebrot](https://github.com/hastebrot))
- \(fix\) `WriteRobot::write()` to prefer the `Scene` of the focused window. [\#239](https://github.com/TestFX/TestFX/pull/239) ([hastebrot](https://github.com/hastebrot))
- \(refactor\) Rename window methods to `targetWindow()`, `listWindows()`, and `window()`. [\#238](https://github.com/TestFX/TestFX/pull/238) ([hastebrot](https://github.com/hastebrot))
- \(feature\) Added ApplicationRule [\#234](https://github.com/TestFX/TestFX/pull/234) ([johnzeringue](https://github.com/johnzeringue))
- \(refactor\) Improve encapsulation of classes. [\#233](https://github.com/TestFX/TestFX/pull/233) ([hastebrot](https://github.com/hastebrot))
- Fixed google group link [\#221](https://github.com/TestFX/TestFX/pull/221) ([joachimprinzbach](https://github.com/joachimprinzbach))
- \(chore\) Travis: Allow jobs without framebuffer to fail. [\#211](https://github.com/TestFX/TestFX/pull/211) ([johnzeringue](https://github.com/johnzeringue))
- \(feat\) `hasTableCell()`: Match the string value of cell item. [\#210](https://github.com/TestFX/TestFX/pull/210) ([johnzeringue](https://github.com/johnzeringue))
- \(chore\) Travis: Run tests once with and once without framebuffer screen. [\#209](https://github.com/TestFX/TestFX/pull/209) ([hastebrot](https://github.com/hastebrot))

## [v4.0.1-alpha](https://github.com/testfx/testfx/tree/v4.0.1-alpha) (2015-03-04)

[Full Changelog](https://github.com/testfx/testfx/compare/v4.0.0-alpha...v4.0.1-alpha)

**Merged pull requests:**

- \(refactor\) Service: Make `NodeFinder` more familiar to JavaFX developers. [\#205](https://github.com/TestFX/TestFX/pull/205) ([hastebrot](https://github.com/hastebrot))
- \(revert\) Legacy: Revert `GuiTest` and remove `ApplicationTest`, `FxTest` and `CustomAppTest`. [\#204](https://github.com/TestFX/TestFX/pull/204) ([hastebrot](https://github.com/hastebrot))
- \(feat\) JUnit: Add support classes, including an `ApplicationTest` base test class. [\#163](https://github.com/TestFX/TestFX/pull/163) ([hastebrot](https://github.com/hastebrot))

## [v4.0.0-alpha](https://github.com/testfx/testfx/tree/v4.0.0-alpha) (2015-02-27)

[Full Changelog](https://github.com/testfx/testfx/compare/v3.1.2...v4.0.0-alpha)

**Merged pull requests:**

- \(doc\) Add Unstable annotations to classes and methods. [\#203](https://github.com/TestFX/TestFX/pull/203) ([hastebrot](https://github.com/hastebrot))
- \(feat\) ListViews provides a row selected matcher. [\#202](https://github.com/TestFX/TestFX/pull/202) ([Ciruman](https://github.com/Ciruman))
- \(chore\) Gradle: Cleanup build scripts. [\#201](https://github.com/TestFX/TestFX/pull/201) ([hastebrot](https://github.com/hastebrot))
- \(fix\) Deprecation and compile warnings caused by dependency upgrades. [\#198](https://github.com/TestFX/TestFX/pull/198) ([hastebrot](https://github.com/hastebrot))
- \(chore\) Gradle: Remove JUnit compile dependency and update Guava. [\#197](https://github.com/TestFX/TestFX/pull/197) ([hastebrot](https://github.com/hastebrot))
- \(doc\) Readme: Update `README.md`. [\#196](https://github.com/TestFX/TestFX/pull/196) ([hastebrot](https://github.com/hastebrot))
- \(feat\) Assert, Matcher: Improve type-aware matchers. [\#195](https://github.com/TestFX/TestFX/pull/195) ([hastebrot](https://github.com/hastebrot))
- \(refactor\) API: Rename pointFor\(\) to point\(\) and add pointOfVisibleNode\(\). [\#194](https://github.com/TestFX/TestFX/pull/194) ([hastebrot](https://github.com/hastebrot))
- \(refactor\) Legacy: Move org.loadui.testfx to testfx-legacy module. [\#192](https://github.com/TestFX/TestFX/pull/192) ([hastebrot](https://github.com/hastebrot))
- \(feat\) Allow instrumenting entire Applications. [\#183](https://github.com/TestFX/TestFX/pull/183) ([0x4a616e](https://github.com/0x4a616e))
- \(doc\) Toolkit: Prepare docs and tests for candidate phase. [\#176](https://github.com/TestFX/TestFX/pull/176) ([hastebrot](https://github.com/hastebrot))
- \(feat\) Service: Implement NodeQuery. [\#174](https://github.com/TestFX/TestFX/pull/174) ([hastebrot](https://github.com/hastebrot))
- \(refactor\) API: Move some org.loadui.testfx classes to org.testfx. [\#172](https://github.com/TestFX/TestFX/pull/172) ([hastebrot](https://github.com/hastebrot))
- \(refactor\) API: Move FxRobot to org.testfx.api. [\#171](https://github.com/TestFX/TestFX/pull/171) ([hastebrot](https://github.com/hastebrot))
- \(refactor\) Toolkit: Prepare API for beta phase. [\#170](https://github.com/TestFX/TestFX/pull/170) ([hastebrot](https://github.com/hastebrot))
- \(feat\) Robot: Support for Unicode strings in WriteRobot. [\#166](https://github.com/TestFX/TestFX/pull/166) ([hastebrot](https://github.com/hastebrot))
- \(refactor\) API: Introduce FxSelector and FxSelectorContext. [\#165](https://github.com/TestFX/TestFX/pull/165) ([hastebrot](https://github.com/hastebrot))
- \(feat\) Assert, Matcher: Implement type-aware matchers. [\#164](https://github.com/TestFX/TestFX/pull/164) ([hastebrot](https://github.com/hastebrot))
- \(feat\) Lifecycle, Robot: Headless support. [\#159](https://github.com/TestFX/TestFX/pull/159) ([hastebrot](https://github.com/hastebrot))
- \(feat\) Lifecycle: Implement LifecycleService. [\#156](https://github.com/TestFX/TestFX/pull/156) ([hastebrot](https://github.com/hastebrot))
- \(refactor\) Util: Enhance RunWaitUtils. [\#154](https://github.com/TestFX/TestFX/pull/154) ([hastebrot](https://github.com/hastebrot))
- \(refactor\) Framework: Extract ToolkitApplication. [\#153](https://github.com/TestFX/TestFX/pull/153) ([hastebrot](https://github.com/hastebrot))
-  \(fix\) Util: Only start waiting for boolean observable when it is false. [\#151](https://github.com/TestFX/TestFX/pull/151) ([hastebrot](https://github.com/hastebrot))
- \(feat\) Util: Provide `invokeIn...()` and `waitFor...()` methods. [\#150](https://github.com/TestFX/TestFX/pull/150) ([hastebrot](https://github.com/hastebrot))
- \(refactor\) Robot: Extract mouse methods to MouseRobotImpl and rename ... [\#149](https://github.com/TestFX/TestFX/pull/149) ([hastebrot](https://github.com/hastebrot))
- \(refactor\) Robot: Revise Robots related to keyboard inputs. [\#147](https://github.com/TestFX/TestFX/pull/147) ([hastebrot](https://github.com/hastebrot))
- \(feat\) Robot: Implement adapters for Awt, Glass and JavaFX robots. [\#146](https://github.com/TestFX/TestFX/pull/146) ([hastebrot](https://github.com/hastebrot))
- \(doc\) Readme: Fix broken links to source code and update links to TestFX... [\#142](https://github.com/TestFX/TestFX/pull/142) ([jotomo](https://github.com/jotomo))
- Respect headless mode instead of enforcing it [\#137](https://github.com/TestFX/TestFX/pull/137) ([sergei-ivanov](https://github.com/sergei-ivanov))
- waffle.io Badge [\#134](https://github.com/TestFX/TestFX/pull/134) ([waffle-iron](https://github.com/waffle-iron))
- make timeout configurable [\#133](https://github.com/TestFX/TestFX/pull/133) ([cwiejack](https://github.com/cwiejack))
- \(chore\) Gradle: Reintroduce BinTray support. [\#128](https://github.com/TestFX/TestFX/pull/128) ([hastebrot](https://github.com/hastebrot))
- \(chore\) Gradle: Temporarily remove BinTray support to fix Gradle view refresh in IntelliJ IDEA. [\#127](https://github.com/TestFX/TestFX/pull/127) ([hastebrot](https://github.com/hastebrot))
- \(fix\) AppLauncher could not retrieve primary Stage on OSX. [\#126](https://github.com/TestFX/TestFX/pull/126) ([hastebrot](https://github.com/hastebrot))
- \(fix\) Matcher: nodeHasLabel\(\) does not perform instance check for Text. [\#124](https://github.com/TestFX/TestFX/pull/124) ([naimdjon](https://github.com/naimdjon))
- Update build files [\#122](https://github.com/TestFX/TestFX/pull/122) ([aalmiray](https://github.com/aalmiray))
- \(chore\) Gradle: Add project.jfxrtLocation to test.classpath. [\#120](https://github.com/TestFX/TestFX/pull/120) ([hastebrot](https://github.com/hastebrot))
- \(chore\) Travis: Try to use xvfb \(X Virtual Framebuffer\). [\#119](https://github.com/TestFX/TestFX/pull/119) ([hastebrot](https://github.com/hastebrot))
- \(chore\) Travis: Add `.travis.yml`. [\#118](https://github.com/TestFX/TestFX/pull/118) ([hastebrot](https://github.com/hastebrot))
- \(chore\) Gradle: Fix missing Gradle wrapper. [\#117](https://github.com/TestFX/TestFX/pull/117) ([hastebrot](https://github.com/hastebrot))
- \(chore\) Gradle: Rerun `gradle wrapper`. [\#116](https://github.com/TestFX/TestFX/pull/116) ([hastebrot](https://github.com/hastebrot))
- \#110: jcenter is not supported in gradle \< 1.7 [\#113](https://github.com/TestFX/TestFX/pull/113) ([naimdjon](https://github.com/naimdjon))
- \(fix\) Add license header to MoveRobotImpl. [\#112](https://github.com/TestFX/TestFX/pull/112) ([hastebrot](https://github.com/hastebrot))
- Update HasLabelStringMatcher.java [\#108](https://github.com/TestFX/TestFX/pull/108) ([torakiki](https://github.com/torakiki))
- \(refactor\) Robot: Refactor FxRobot. [\#105](https://github.com/TestFX/TestFX/pull/105) ([hastebrot](https://github.com/hastebrot))
- \(fix\) Compiler warnings for deprecated JUnit methods. [\#104](https://github.com/TestFX/TestFX/pull/104) ([hastebrot](https://github.com/hastebrot))
- \(fix\) Service: Fix compatibility to Java 7 and JavaFX 2. [\#103](https://github.com/TestFX/TestFX/pull/103) ([hastebrot](https://github.com/hastebrot))
- \(refactor\) Robot: Refactor TypeRobotImpl. [\#102](https://github.com/TestFX/TestFX/pull/102) ([hastebrot](https://github.com/hastebrot))
- \(refactor\) Robot: Add regression tests and refactor KeyboardRobotImpl. [\#101](https://github.com/TestFX/TestFX/pull/101) ([hastebrot](https://github.com/hastebrot))
- \(refactor\) Robot: Add regression tests and refactor ScrollRobotImpl. [\#100](https://github.com/TestFX/TestFX/pull/100) ([hastebrot](https://github.com/hastebrot))
- \(test\) Move ScrollPaneTest from unit tests to integration tests. [\#99](https://github.com/TestFX/TestFX/pull/99) ([hastebrot](https://github.com/hastebrot))
- \(feat\) Robot: Add regression tests and create DragRobotImpl. [\#98](https://github.com/TestFX/TestFX/pull/98) ([hastebrot](https://github.com/hastebrot))
- \(feat\) Robot: Add regression tests and create ClickRobotImpl. [\#97](https://github.com/TestFX/TestFX/pull/97) ([hastebrot](https://github.com/hastebrot))
- \(feat\) Robot: Add regression tests and create MoveRobotImpl. [\#96](https://github.com/TestFX/TestFX/pull/96) ([hastebrot](https://github.com/hastebrot))
- Fix scroll direction as UP was going down \(and DOWN up\). [\#95](https://github.com/TestFX/TestFX/pull/95) ([lgringo](https://github.com/lgringo))
- \(refactor\) Robot: Add regression tests and refactor MouseRobotImpl. [\#94](https://github.com/TestFX/TestFX/pull/94) ([hastebrot](https://github.com/hastebrot))
- Extract static methods from FxRobot to GuiTest [\#91](https://github.com/TestFX/TestFX/pull/91) ([hastebrot](https://github.com/hastebrot))
- \(chore\) Gradle: Build now runs with `gradle clean jar javadocJar sourceJar test check`. [\#88](https://github.com/TestFX/TestFX/pull/88) ([hastebrot](https://github.com/hastebrot))
- \(fix\) Service: Calls to `Point2D#add()` incompatible with Java 7. [\#87](https://github.com/TestFX/TestFX/pull/87) ([hastebrot](https://github.com/hastebrot))
- Setup a multi-project Gradle build [\#71](https://github.com/TestFX/TestFX/pull/71) ([aalmiray](https://github.com/aalmiray))
- \(feat\) Implement CallableBoundsPointQuery. [\#68](https://github.com/TestFX/TestFX/pull/68) ([hastebrot](https://github.com/hastebrot))
- Fix NP in containsCell in TableViews [\#67](https://github.com/TestFX/TestFX/pull/67) ([rladstaetter](https://github.com/rladstaetter))
- No longer fixed scene size. [\#62](https://github.com/TestFX/TestFX/pull/62) ([minisu](https://github.com/minisu))
- Misc fixes + bumped version. [\#61](https://github.com/TestFX/TestFX/pull/61) ([minisu](https://github.com/minisu))
- Now releases keys/buttons on test aborted. \#23 [\#60](https://github.com/TestFX/TestFX/pull/60) ([minisu](https://github.com/minisu))
- Now aborts test on user mouse movement. Related to \#55 [\#59](https://github.com/TestFX/TestFX/pull/59) ([minisu](https://github.com/minisu))
- \(refactor\) Extract robot and service classes from GuiTest. [\#39](https://github.com/TestFX/TestFX/pull/39) ([hastebrot](https://github.com/hastebrot))

## [v3.1.2](https://github.com/testfx/testfx/tree/v3.1.2) (2014-01-30)

[Full Changelog](https://github.com/testfx/testfx/compare/v3.1.0...v3.1.2)

**Merged pull requests:**

- \#47: getVisibleNodes\(\) returns normal static Set [\#48](https://github.com/TestFX/TestFX/pull/48) ([Philipp91](https://github.com/Philipp91))
- \#43: push\(\) does not wait between press/release calls [\#45](https://github.com/TestFX/TestFX/pull/45) ([Philipp91](https://github.com/Philipp91))

## [v3.1.0](https://github.com/testfx/testfx/tree/v3.1.0) (2014-01-12)

[Full Changelog](https://github.com/testfx/testfx/compare/v3.0.0...v3.1.0)

**Merged pull requests:**

- Faster mouse movement over long distances [\#35](https://github.com/TestFX/TestFX/pull/35) ([Philipp91](https://github.com/Philipp91))

## [v3.0.0](https://github.com/testfx/testfx/tree/v3.0.0) (2013-12-23)

[Full Changelog](https://github.com/testfx/testfx/compare/101caed2ea9b5dc58400deee8dab042d1722565c...v3.0.0)

**Merged pull requests:**

- Add a Bitdeli Badge to README [\#26](https://github.com/TestFX/TestFX/pull/26) ([bitdeli-chef](https://github.com/bitdeli-chef))
- Corrected verifyThat\(\) to accept super-Matchers [\#22](https://github.com/TestFX/TestFX/pull/22) ([Philipp91](https://github.com/Philipp91))



\* *This Changelog was automatically generated by [github_changelog_generator](https://github.com/github-changelog-generator/github-changelog-generator)*
